package ml2java.examples;

import ml2java.parser.*;
import static ml2java.parser.Operation.*;
import static ml2java.parser.Exp.*;
import static ml2java.parser.Comm.*;

public class Example1 {

	/* Some example */
	/*
	static int test1(int inf, int sup) { 
		int sum, i;
		sum = 0;
		i = inf;
		while (i <= sup) {
			sum = sum + i;
			i = i + 1; 
		};
		return sum; 
	}
	*/
	
	/* Abstract syntax of the above example */
	static Comm c = 
	   Seq (
	     CommRegion (
	       Assign (
	         "sum",
	         IntCst (
	           0
	         )
	       ),
	       3,
	       3
	     ),
	     Seq (
	       CommRegion (
	         Assign (
	           "i",
	           Var (
	             "inf"
	           )
	         ),
	         4,
	         4
	       ),
	       Seq (
	         CommRegion (
	           While (
	             Oper (
	               LessEq (
	               ),
	               Var (
	                 "i"
	               ),
	               Var (
	                 "sup"
	               )
	             ),
	             CommRegion (
	               Seq (
	                 CommRegion (
	                   Assign (
	                     "sum",
	                     Oper (
	                       Plus (
	                       ),
	                       Var (
	                         "sum"
	                       ),
	                       Var (
	                         "i"
	                       )
	                     )
	                   ),
	                   6,
	                   6
	                 ),
	                 CommRegion (
	                   Assign (
	                     "i",
	                     Oper (
	                       Plus (
	                       ),
	                       Var (
	                         "i"
	                       ),
	                       IntCst (
	                         1
	                       )
	                     )
	                   ),
	                   7,
	                   7
	                 )
	               ),
	               5,
	               8
	             )
	           ),
	           5,
	           8
	         ),
	         CommRegion (
	           Assign (
	        	 "result", 
	        	 Var (
	        	  "sum"
	        	 )
	           ),
	           9,
	           9
	         )
	       )
	     )
	   );

}
